<!DOCTYPE html><html lang="en"><head><meta charSet="utf-8"/><meta http-equiv="X-UA-Compatible" content="IE=edge"/><title>Well Known Properties · Merge</title><meta name="viewport" content="width=device-width"/><meta name="generator" content="Docusaurus"/><meta name="description" content="&lt;p&gt;&lt;link rel=&quot;stylesheet&quot; type=&quot;text/css&quot; href=&quot;/css/api.css&quot;&gt;&lt;/p&gt;
"/><meta name="docsearch:language" content="en"/><meta property="og:title" content="Well Known Properties · Merge"/><meta property="og:type" content="website"/><meta property="og:url" content="https://mergetb.gitlab.io/index.html"/><meta property="og:description" content="&lt;p&gt;&lt;link rel=&quot;stylesheet&quot; type=&quot;text/css&quot; href=&quot;/css/api.css&quot;&gt;&lt;/p&gt;
"/><meta property="og:image" content="https://mergetb.gitlab.io/img/logo.png"/><meta name="twitter:card" content="summary"/><meta name="twitter:image" content="https://mergetb.gitlab.io/img/logo.png"/><link rel="shortcut icon" href="/img/merge.png"/><link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/dracula.min.css"/><link rel="alternate" type="application/atom+xml" href="https://mergetb.gitlab.io/blog/atom.xml" title="Merge Blog ATOM Feed"/><link rel="alternate" type="application/rss+xml" href="https://mergetb.gitlab.io/blog/feed.xml" title="Merge Blog RSS Feed"/><script type="text/javascript" src="https://buttons.github.io/buttons.js"></script><link rel="stylesheet" href="/css/main.css"/></head><body class="sideNavVisible separateOnPageNav"><div class="fixedHeaderContainer"><div class="headerWrapper wrapper"><header><a href="/"><img class="logo" src="/img/merge-light.svg" alt="Merge"/><h2 class="headerTitleWithLogo">Merge</h2></a><div class="navigationWrapper navigationSlider"><nav class="slidingNav"><ul class="nav-site nav-site-internal"><li class="siteNavGroupActive"><a href="/docs/hello-world.html" target="_self">Experimentation</a></li><li class=""><a href="/docs/site-basics.html" target="_self">Site Hosting</a></li><li class=""><a href="/docs/portal-admin.html" target="_self">Portal Hosting</a></li><li class=""><a href="/docs/tech.html" target="_self">Technology</a></li><li class=""><a href="/blog/" target="_self">News</a></li></ul></nav></div></header></div></div><div class="navPusher"><div class="docMainWrapper wrapper"><div class="container docsNavContainer" id="docsNav"><nav class="toc"><div class="toggleNav"><section class="navWrapper wrapper"><div class="navBreadcrumb wrapper"><div class="navToggle" id="navToggler"><i></i></div><h2><i>›</i><span>Reference</span></h2><div class="tocToggler" id="tocToggler"><i class="icon-toc"></i></div></div><div class="navGroups"><div class="navGroup"><h3 class="navGroupCategoryTitle">Getting Started</h3><ul><li class="navListItem"><a class="navItem" href="/docs/hello-world.html">Hello World tl;dr</a></li><li class="navListItem"><a class="navItem" href="/docs/hello-world-tutorial.html">Hello World Tutorial</a></li></ul></div><div class="navGroup"><h3 class="navGroupCategoryTitle">Examples</h3><ul><li class="navListItem"><a class="navItem" href="/docs/snowflake.html">Snowflake</a></li></ul></div><div class="navGroup"><h3 class="navGroupCategoryTitle">Reference</h3><ul><li class="navListItem"><a class="navItem" href="/docs/merge-api.html">Merge API</a></li><li class="navListItem"><a class="navItem" href="/docs/toporef.html">Topology</a></li><li class="navListItem navListItemActive"><a class="navItem" href="/docs/well-known.html">Well Known Properties</a></li><li class="navListItem"><a class="navItem" href="/docs/image-support.html">Image Support</a></li></ul></div></div></section></div><script>
            document.addEventListener('DOMContentLoaded', function() {
              createToggler('#navToggler', '#docsNav', 'docsSliderActive');
              createToggler('#tocToggler', 'body', 'tocActive');

              const headings = document.querySelector('.toc-headings');
              headings && headings.addEventListener('click', function(event) {
                if (event.target.tagName === 'A') {
                  document.body.classList.remove('tocActive');
                }
              }, false);

              function createToggler(togglerSelector, targetSelector, className) {
                var toggler = document.querySelector(togglerSelector);
                var target = document.querySelector(targetSelector);

                if (!toggler) {
                  return;
                }

                toggler.onclick = function(event) {
                  event.preventDefault();

                  target.classList.toggle(className);
                };
              }
            });
        </script></nav></div><div class="container mainContainer"><div class="wrapper"><div class="post"><header class="postHeader"><h1 class="postHeaderTitle">Well Known Properties</h1></header><article><div><span><p><link rel="stylesheet" type="text/css" href="/css/api.css"></p>
<p>XIR object properties are open ended and can carry arbitrary data.</p>
<h2><a class="anchor" aria-hidden="true" id="node"></a><a href="#node" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Node</h2>
<h3><a class="anchor" aria-hidden="true" id="hardware"></a><a href="#hardware" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Hardware</h3>
<pre><code class="hljs css language-mypy">{
  procs: [<span class="hljs-type">P</span><span class="hljs-type">r</span><span class="hljs-type">o</span><span class="hljs-type">c</span>],
  memory: [<span class="hljs-type">M</span><span class="hljs-type">e</span><span class="hljs-type">m</span><span class="hljs-type">o</span><span class="hljs-type">r</span><span class="hljs-type">y</span><span class="hljs-type">M</span><span class="hljs-type">o</span><span class="hljs-type">d</span><span class="hljs-type">u</span><span class="hljs-type">l</span><span class="hljs-type">e</span>]
}
</code></pre>
<h4><a class="anchor" aria-hidden="true" id="proc"></a><a href="#proc" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Proc</h4>
<pre><code class="hljs css language-mypy">{
  model: <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>
  speed: <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span> <span class="hljs-comment"># unit: Hz</span>
  cores: <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>
  l2:    <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span> <span class="hljs-comment"># unit: MB</span>
  l3:    <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span> <span class="hljs-comment"># unit: MB</span>
  pcie: {
    version: <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>
    lanes:   <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>
  }
}
</code></pre>
<h4><a class="anchor" aria-hidden="true" id="memorymodule"></a><a href="#memorymodule" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>MemoryModule</h4>
<pre><code class="hljs css language-mypy">{
  model: <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>
  speed: <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span> <span class="hljs-comment"># unit: Hz</span>
  size:  <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span> <span class="hljs-comment"># unit: MB</span>
  protocol: {
    name: <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span>
    version: <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span>
  }
}
</code></pre>
<h3><a class="anchor" aria-hidden="true" id="software-configuration"></a><a href="#software-configuration" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Software Configuration</h3>
<pre><code class="hljs css language-mypy">{
  osimage: <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span> <span class="hljs-comment"># operating system image</span>
  fwimage: <span class="hljs-type">s</span><span class="hljs-type">t</span><span class="hljs-type">r</span><span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">g</span> <span class="hljs-comment"># firmware image</span>
}
</code></pre>
<h2><a class="anchor" aria-hidden="true" id="link"></a><a href="#link" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Link</h2>
<pre><code class="hljs css language-mypy">{
  latency:  <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span> <span class="hljs-comment"># unit: nanoseconds</span>
  loss:     <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span> <span class="hljs-comment"># unit: percent</span>
  ber:      <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span> <span class="hljs-comment"># unit: packets per billion</span>
  capacity: <span class="hljs-type">i</span><span class="hljs-type">n</span><span class="hljs-type">t</span> <span class="hljs-comment"># unit: bits per second</span>
  mode:     <span class="hljs-type">E</span><span class="hljs-type">n</span><span class="hljs-type">u</span><span class="hljs-type">m</span>[<span class="hljs-type">p</span><span class="hljs-type">2</span><span class="hljs-type">p</span>,<span class="hljs-type">h</span><span class="hljs-type">u</span><span class="hljs-type">b</span>,<span class="hljs-type">s</span><span class="hljs-type">w</span><span class="hljs-type">i</span><span class="hljs-type">t</span><span class="hljs-type">c</span><span class="hljs-type">h</span>]
}
</code></pre>
</span></div></article></div><div class="docs-prevnext"><a class="docs-prev button" href="/docs/toporef.html"><span class="arrow-prev">← </span><span>Topology</span></a><a class="docs-next button" href="/docs/image-support.html"><span>Image Support</span><span class="arrow-next"> →</span></a></div></div></div><nav class="onPageNav"><ul class="toc-headings"><li><a href="#node">Node</a><ul class="toc-headings"><li><a href="#hardware">Hardware</a></li><li><a href="#software-configuration">Software Configuration</a></li></ul></li><li><a href="#link">Link</a></li></ul></nav></div><footer class="nav-footer" id="footer"><section class="sitemap"><a href="/" class="nav-home"><img src="/img/merge-light.svg" alt="Merge" width="66" height="58"/></a><div><h5>Docs</h5><a href="/docs/en/hello-world.html">Experimentation</a><a href="/docs/en/site-basics.html">Site Hosting</a><a href="/docs/en/portal-admin.html">Portal Hosting</a></div><div><h5>Community</h5><a href="/en/users.html">User Showcase</a><a href="https://mergetb.slack.com/">Project Chat</a></div><div><h5>More</h5><a href="/blog">Blog</a><a href="https://gitlab.com/mergetb">GitLab</a></div></section><section class="copyright">Copyright © 2018 Information Sciences Institute</section></footer></div></body></html>